<#ibizinclude>
../../../@MACRO/LANG_FUN.ftl
</#ibizinclude>
<#macro nextUIActionLogic resultData>
    <#if item.isReloadData?? && item.isReloadData()>
            if (xData && xData.refresh && xData.refresh instanceof Function) {
                xData.refresh(args);
            }
    </#if>
    <#if item.isCloseEditView()>
            actionContext.closeView(null);
    </#if>
    <#if item.getNextPSUIAction?? && item.getNextPSUIAction()??>
        <#assign nextPSUIAction = item.getNextPSUIAction()/>
        <#if !(nextPSUIAction.getPSAppDataEntity?? && nextPSUIAction.getPSAppDataEntity()??)>
            if (_this.${nextPSUIAction.getFullCodeName()} && _this.${nextPSUIAction.getFullCodeName()} instanceof Function) {
                return _this.${nextPSUIAction.getFullCodeName()}(result.datas, context, params, $event, xData, actionContext);
            }
        <#else>
    if (this.${nextPSUIAction.getFullCodeName()} && this.${nextPSUIAction.getFullCodeName()} instanceof Function) {
        return this.${nextPSUIAction.getFullCodeName()}(result.datas, context, params, $event, xData, actionContext);
    }
        </#if>
    <#else>
        <#if item.getUILogicAttachMode?? && item.getUILogicAttachMode()?? && item.getUILogicAttachMode() == 'AFTER' && item.getPSAppDEUILogic?? && item.getPSAppDEUILogic()??>
            const _context: any = Object.assign(context, actionContext.context);
            const _params: any = Object.assign(params, actionContext.viewparams);
            <#if item.getPSAppDataEntity?? && item.getPSAppDataEntity()?? && item.getPSAppDEUILogic().getPSAppDataEntity?? && item.getPSAppDEUILogic().getPSAppDataEntity()?? && item.getPSAppDataEntity().codeName == item.getPSAppDEUILogic().getPSAppDataEntity().codeName>
            return this.executeUILogic('${item.getPSAppDEUILogic().codeName}', args, _context, _params, $event, xData, actionContext, srfParentDeName);
            <#elseif item.getPSAppDEUILogic().getPSAppDataEntity?? && item.getPSAppDEUILogic().getPSAppDataEntity()??>
            const uiService = await window.uiServiceRegister.getService('${item.getPSAppDEUILogic().getPSAppDataEntity().codeName?lower_case}');
            if (uiService) {
                return uiService.executeUILogic('${item.getPSAppDEUILogic().codeName}', args, _context, _params, $event, xData, actionContext, srfParentDeName);
            }
            </#if>
        <#else>
            return { ok: true, result: ${resultData} };
        </#if>
    </#if>
</#macro>
<#--  前台界面行为  -->
<#if front_block??>
${front_block}
<#else>
    /**
     * ${item.getCaption()}
     *
     * @param {any[]} args 当前数据
     * @param {any} context 行为附加上下文
     * @param {*} [params] 附加参数
     * @param {*} [$event] 事件源
     * @param {*} [xData]  执行行为所需当前部件
     * @param {*} [actionContext]  执行行为上下文
     * @param {*} [srfParentDeName] 父实体名称
     * @returns {Promise<any>}
    <#if item.getPSAppDataEntity?? && item.getPSAppDataEntity()??>
     * @memberof ${srfclassname('${item.getPSAppDataEntity().getCodeName()}')}UIService
    </#if>
     */
    public async ${item.getFullCodeName()}(args: any[], context:any = {}, params: any={}, $event?: any, xData?: any, actionContext?: any, srfParentDeName?:string) {
    <#if item.render??>
        ${item.render.code}
    <#else>
        <#--  界面逻辑替换执行  -->
        <#if item.getUILogicAttachMode?? && item.getUILogicAttachMode()?? && item.getUILogicAttachMode() == 'REPLACE' && item.getPSAppDEUILogic?? && item.getPSAppDEUILogic()??>
        const _context: any = Object.assign(context, actionContext.context);
        const _params: any = Object.assign(params, actionContext.viewparams);
            <#if item.getPSAppDataEntity?? && item.getPSAppDataEntity()?? && item.getPSAppDEUILogic().getPSAppDataEntity?? && item.getPSAppDEUILogic().getPSAppDataEntity()?? && item.getPSAppDataEntity().codeName == item.getPSAppDEUILogic().getPSAppDataEntity().codeName>
        return this.executeUILogic('${item.getPSAppDEUILogic().codeName}', args, _context, _params, $event, xData, actionContext, srfParentDeName);
            <#elseif item.getPSAppDEUILogic().getPSAppDataEntity?? && item.getPSAppDEUILogic().getPSAppDataEntity()??>
        const uiService = await window.uiServiceRegister.getService('${item.getPSAppDEUILogic().getPSAppDataEntity().codeName?lower_case}');
        if (uiService) {
            return uiService.executeUILogic('${item.getPSAppDEUILogic().codeName}', args, _context, _params, $event, xData, actionContext, srfParentDeName);
        }
            </#if>
        <#else>
        <#--  BEGIN: 数据处理逻辑  -->
        let data: any = {};
        let tempData: any = {};
        let tempContext: any = {};
        let tempViewParam: any = {};
        const _this: any = actionContext;
        <#-- 是否先保存目标数据start -->
            <#if item.isSaveTargetFirst()>
        const result:any = await xData.save(args,false);
                <#if item.getActionTarget() == 'SINGLEDATA'>
        Object.assign(args[0], result.data);
                <#else>
        args = [result.data];
                </#if>
            </#if>
         <#-- 是否先保存目标数据end -->
        const _args: any[] = Util.deepCopy(args);
        const actionTarget: string | null = <#if item.getActionTarget()??>'${item.getActionTarget()}'<#else>null</#if>;
            <#if item.getPSAppDataEntity?? && item.getPSAppDataEntity()??>
                <#assign appDataEntity = item.getPSAppDataEntity() />
                <#if item.getActionTarget() == 'SINGLEKEY' || item.getActionTarget() == 'MULTIKEY'>
                    <#assign valueItem><#if item.getValueItem?? && item.getValueItem() != ''>${item.getValueItem()}<#else>${appDataEntity.getKeyPSAppDEField().getCodeName()?lower_case}</#if></#assign>
                    <#assign paramItem><#if item.getParamItem?? && item.getParamItem() != ''>${item.getParamItem()}<#else>${appDataEntity.getCodeName()?lower_case}</#if></#assign>
                    <#assign textItem><#if item.getTextItem?? && item.getTextItem() != ''>${item.getTextItem()}<#else>${appDataEntity.getMajorPSAppDEField().getCodeName()?lower_case}</#if></#assign>
        if (_args && args[0] && args[0]['${valueItem}']) {
            Object.assign(tempContext, { ${appDataEntity.codeName?lower_case}: '%${valueItem}%' });
        } else {
            Object.assign(tempContext, { ${appDataEntity.codeName?lower_case}: '%${paramItem}%' });
        }
        Object.assign(tempViewParam, { ${valueItem}: '%${paramItem}%' });
        Object.assign(tempViewParam, { ${textItem}: '%${textItem}%' });
                </#if>
            </#if>
            <#if item.getPSNavigateContexts?? && item.getPSNavigateContexts()??>
        Object.assign(tempContext, <@getNavigateContext item />);
            </#if>
            <#if item.getPSNavigateParams?? && item.getPSNavigateParams()??>
        Object.assign(tempViewParam, <@getNavigateParams item />);
            </#if>
        tempContext = UIActionTool.handleContextParam(actionTarget, _args, context, params, tempContext);
            <#if item.getActionTarget() == 'SINGLEDATA'>
        tempData = UIActionTool.handleActionParam(actionTarget, _args, context, params, tempViewParam);
        Object.assign(data, tempData);
            <#else>
        tempViewParam = UIActionTool.handleActionParam(actionTarget, _args, context, params, tempViewParam);
            </#if>
        Object.assign(context, tempContext);
        Object.assign(params, data);
        <#-- 构建srfparentdename和srfparentkey start -->
        let parentObj:any = {
            srfparentdename: srfParentDeName ? srfParentDeName : null,
            srfparentkey: srfParentDeName ? context[srfParentDeName.toLowerCase()] : null
        };
        Object.assign(context, parentObj);
        <#-- 构建srfparentdename和srfparentkey end -->
    <#--  END: 数据处理逻辑  -->
    <#--  BEGIN: 前台处理模式：用户自定义  -->
            <#if item.getFrontProcessType() == 'OTHER'>
                <#if item.getScriptCode?? && item.getScriptCode()??>
        const executeScriptCode = () => {
            const data = args;
            eval(${item.getScriptCode()});
        }
        return executeScriptCode();
                <#else>
        console.warn('自定义前端界面行为无脚本内容');
                </#if>
    <#--  END: 前台处理模式：用户自定义  -->
    <#--  BEGIN: 前台处理模式：打印  -->
            <#elseif item.getFrontProcessType() == 'PRINT'>
                <#if item.getPSAppDEPrint?? && item.getPSAppDEPrint()??>
        let requestUrl: string = '';
        if (context && context['${item.getPSAppDataEntity().codeName?lower_case}']) {
            requestUrl += `/${srfpluralize(item.getPSAppDataEntity().codeName)}/printdata/<#noparse>${context[${</#noparse>${item.getPSAppDataEntity().codeName?lower_case}}]}`;
            //  存在父添加父主键信息
            if (actionContext.context && actionContext.context.srfparentdename && actionContext.context.srfparentkey) {
                <#noparse>requestUrl = `/${Util.srfpluralize(actionContext.context.srfparentdename).toLowerCase()}/${actionContext.context.srfparentkey}` + requestUrl;</#noparse>
            }
        } else {
            actionContext.$Notice.error({ title: '错误', desc: 'actionContext.$t('app.utilview.nodatakey')' });
            return;
        }
        requestUrl += '?srfprinttag=${item.getPSAppDEPrint().codeName}';
        const response = await axios({
            url: requestUrl,
            method: 'get',
            responseType: 'blob'
        });
        if (response.status === 200 && response.data) {
            const link = window.URL.createObjectURL(response.data);
            window.open(link, '_blank');
        } else {
            actionContext.$Notice.error({ title: '错误', desc: 'actionContext.$t('app.utilview.printerror')' });
        }
                <#else>
        actionContext.$Notice.error({ title: '错误', desc: 'actionContext.$t('app.utilview.noprint')' });
                </#if>
    <#--  END: 前台处理模式：打印  -->
    <#--  BEGIN: 前台处理模式：数据导入  -->
            <#elseif item.getFrontProcessType() == 'DATAIMP'>
                <#if item.getPSAppDEDataImport?? && item.getPSAppDEDataImport()??>
        const view: any = {
            viewname: 'app-data-upload',
            title: actionContext.$t("app.utilview.importview"),
            width: 544,
            height: 368,
            customClass: 'app-data-upload-modal view-default'
        }
        if (actionContext.context && actionContext.context.srfparentdename && actionContext.context.srfparentkey) {
            Object.assign(context, { srfparentdename: actionContext.context.srfparentdename });
            Object.assign(context, { srfparentkey: actionContext.context.srfparentkey });
        } else {
            if (context.srfparentdename) {
                delete context.srfparentdename;
            }
            if (context.srfparentkey) {
                delete context.srfparentkey;
            }
        }
        const container: Subject<any> = actionContext.$appmodal.openModal(view, context, {
            importId: '${item.getPSAppDEDataImport().codeName}',
            serviceName: '${item.getPSAppDataEntity().codeName}',
            appDeLogicName: '${item.getPSAppDataEntity().logicName}',
            ignoreError: <#if item.getPSAppDEDataImport().getIgnoreError?? && item.getPSAppDEDataImport().getIgnoreError()>true<#else>false</#if>
        });
        container.subscribe((result: any) => {
            if (Object.is(result.ret, 'OK')) {
                actionContext.refresh(result.datas);
            }
        });
                <#else>
        actionContext.$Notice.warning({ title: '警告', desc: 'actionContext.$t('app.utilview.info')' });
                </#if>
    <#--  END: 前台处理模式：数据导入  -->
    <#--  BEGIN: 前台处理模式：数据导出  -->
            <#elseif item.getFrontProcessType() == 'DATAEXP'>
                <#if item.getPSAppDEDataExport?? && item.getPSAppDEDataExport()??>
        let url: string = '/${srfpluralize(appDataEntity.codeName)?lower_case}/exportdata/fetchdefault';
        if (actionContext.context && actionContext.context.srfparentdename && actionContext.context.srfparentkey) {
            <#noparse>url = `/${Util.srfpluralize(actionContext.context.srfparentdename).toLowerCase()}/${actionContext.context.srfparentkey}` + url;</#noparse>
        }
        url += '?srfexporttag=${item.getPSAppDEDataExport().codeName}';
        const requestParams: any = {};
        Object.assign(requestParams, { page: 0, size: <#if item.getPSAppDEDataExport().getMaxRowCount?? && item.getPSAppDEDataExport().getMaxRowCount()??>${item.getPSAppDEDataExport().getMaxRowCount()?c}<#else>1000</#if> });
        try {
            const response = await axios({
                url: url,
                method: 'post',
                data: requestParams,
                responseType: 'blob'
            });
            const fileName = decodeURIComponent('${item.getPSAppDataEntity().logicName}.xlsx');
            let blob = new Blob([response.data], { type: 'application/vnd.ms-excel' });
            let elink = document.createElement('a');
            elink.download = fileName;
            elink.style.display = 'none';
            elink.href = URL.createObjectURL(blob);
            document.body.appendChild(elink);
            elink.click();
            URL.revokeObjectURL(elink.href); // 释放URL 对象
            document.body.removeChild(elink);
        } catch (error: any) {
            try {
                const reader = new FileReader();
                reader.readAsText(error.data, 'utf-8');
                reader.onload = (event: any) => {
                    const message = JSON.parse(event.target.result)?.message;
                    actionContext.$Notice.error({ title: '错误', desc: 'actionContext.$t('app.grid.exportexcel.error')' });
                }
            } catch (error) {
                actionContext.$Notice.error({ title: '错误', desc: 'actionContext.$t('app.grid.exportexcel.error')' });
            }
        }
                <#else>
        actionContext.$Notice.warning({ title: '警告', desc: 'actionContext.$t('app.grid.exportexcel.error')' });
                </#if>
    <#--  END: 前台处理模式：数据导出  -->
    <#--  BEGIN: 前台处理模式：打开HTML  -->
            <#elseif item.getFrontProcessType() == 'OPENHTMLPAGE'>
        <#--  打开独立程序弹出  -->
        const openPopupApp = (url: string) => {
            window.open(url, '_blank');
            return { ok: true, result: _args };
        }
        const url = `${item.getHtmlPageUrl()}`;
        return openPopupApp(url);
    <#--  END: 前台处理模式：打开HTML  -->
    <#--  BEGIN: 前台处理模式：打开顶级视图，打开顶级视图或向导（模态）  -->
            <#elseif (item.getFrontProcessType() == 'TOP' || item.getFrontProcessType() == 'WIZARD') && item.getFrontPSAppView()??>
                <#assign dataview = item.getFrontPSAppView()>
      <#--  BEGIN：准备参数  -->
                <#if dataview.isRedirectView()>
        const deResParameters: any[] = [];
        const parameters: any[] = [];
                <#else>
        <#--  BEGIN：是否应用实体视图  -->
                    <#if dataview.isPSDEView()>
        <#-- 存在关系start -->
                        <#if dataview.getPSAppDERSPathCount() gt 0>
                            <#list 1..dataview.getPSAppDERSPathCount() as count>
                                <#assign condition = ''/>
                                <#list dataview.getPSAppDERSPath(count_index)  as deRSPath>
                                    <#if deRSPath.getMajorPSAppDataEntity?? && deRSPath.getMajorPSAppDataEntity()??>
                                        <#assign _dataEntity = deRSPath.getMajorPSAppDataEntity()/>
                                        <#assign condition>${condition}context.${_dataEntity.getCodeName()?lower_case} && </#assign>
                                    </#if>
                                </#list>
                            </#list>
        let deResParameters: any[] = [];
        <#-- 如果是主实体需对context判断start -->
                            <#if dataview.getPSAppDataEntity().isMajor()>
        if(${condition}true){
            deResParameters = [
                                <#list dataview.getPSAppDERSPath(dataview.getPSAppDERSPathCount() - 1) as deRSPath>
                                    <#assign majorPSAppDataEntity = deRSPath.getMajorPSAppDataEntity()/>
            { pathName: '${srfpluralize(majorPSAppDataEntity.codeName)?lower_case}', parameterName: '${majorPSAppDataEntity.getCodeName()?lower_case}' },
                                </#list>
            ]
        }
                            <#else>
        deResParameters = [
                                <#list dataview.getPSAppDERSPath(dataview.getPSAppDERSPathCount() - 1) as deRSPath>
                                    <#assign majorPSAppDataEntity = deRSPath.getMajorPSAppDataEntity()/>
            { pathName: '${srfpluralize(majorPSAppDataEntity.codeName)?lower_case}', parameterName: '${majorPSAppDataEntity.getCodeName()?lower_case}' },
                                </#list>
        ];
                            </#if>
        <#-- 如果是主实体需对context判断end -->
                        <#else>
        let deResParameters: any[] = [];
                        </#if>
        <#-- 存在关系end -->
                    <#else>
        const deResParameters: any[] = [];
                    </#if>
        <#--  END：是否应用实体视图  -->
                    <#if dataview.getOpenMode() == 'INDEXVIEWTAB' || dataview.getOpenMode() == ''>
          <#--  BEGIN：是否应用实体视图  -->
                        <#if dataview.isPSDEView()>
                            <#assign appDataEntity = dataview.getPSAppDataEntity()/>
        const parameters: any[] = [
            { pathName: '${srfpluralize(appDataEntity.codeName)?lower_case}', parameterName: '${appDataEntity.getCodeName()?lower_case}' },
            { pathName: '${dataview.getPSDEViewCodeName()?lower_case}', parameterName: '${dataview.getPSDEViewCodeName()?lower_case}' },
        ];
                        <#else>
        const parameters: any[] = [
            { pathName: '${dataview.getCodeName()?lower_case}', parameterName: '${dataview.getCodeName()?lower_case}' },
        ];
                        </#if>
          <#--  END：是否应用实体视图  -->
                    <#else>
          <#--  BEGIN：是否应用实体视图  -->
                        <#if dataview.isPSDEView()>
                            <#assign appDataEntity = dataview.getPSAppDataEntity()/>
        const parameters: any[] = [
            { pathName: '${srfpluralize(appDataEntity.codeName)?lower_case}', parameterName: '${appDataEntity.getCodeName()?lower_case}' },
        ];
                        <#else>
        const parameters: any[] = [];
                        </#if>
          <#--  END：是否应用实体视图  -->
                    </#if>
                </#if>
      <#--  END：准备参数  -->
      <#--  BEGIN: 打开重定向视图  -->
                <#if dataview.isRedirectView()>
        <#-- BEGIN: 打开顶级分页视图  -->
        // 打开顶级分页视图
        const openIndexViewTab = (viewpath: string, data: any) => {
            const _params = actionContext.$util.prepareRouteParmas({
                route: actionContext.$route,
                sourceNode: actionContext.$route.name,
                targetNode: viewpath,
                data: data,
            });
            actionContext.$router.push({ name: viewpath, params: _params });
            //  后续界面行为
            <@nextUIActionLogic 'args' />
        }
        <#-- END: 打开顶级分页视图  -->
        <#-- BEGIN: 打开模态  -->
        // 打开模态
        const openPopupModal = (view: any, data: any) => {
            let container: Subject<any> = actionContext.$appmodal.openModal(view,context,data);
            container.subscribe((result: any) => {
                if (!result || !Object.is(result.ret, 'OK')) {
                    return;
                }
                //  后续界面行为
                <@nextUIActionLogic 'result.datas' />
            });
        }
        <#-- END: 打开模态  -->
        <#-- BEGIN: 打开抽屉  -->
        // 打开抽屉
        const openDrawer = (view: any, data: any) => {
            let container: Subject<any> = actionContext.$appdrawer.openDrawer(view,context, data);
            container.subscribe((result: any) => {
                if (!result || !Object.is(result.ret, 'OK')) {
                    return;
                }
                const _this: any = actionContext;
                //  后续界面行为
                <@nextUIActionLogic 'result.datas' />
            });
        }
        <#-- END: 打开抽屉  -->
        <#-- BEGIN: 打开气泡卡片  -->
        // 打开气泡卡片
        const openPopOver = (view: any, data: any) => {
            let container: Subject<any> = actionContext.$apppopover.openPop($event, view,context, data);
            container.subscribe((result: any) => {
                if (!result || !Object.is(result.ret, 'OK')) {
                    return;
                }
                const _this: any = actionContext;
                //  后续界面行为
                <@nextUIActionLogic 'result.datas' />
            });
        }
        <#-- END: 打开气泡卡片  -->
        <#-- BEGIN: 打开独立程序弹出  -->
        // 打开独立程序弹出 
        const openPopupApp = (url: string) => {
            window.open(url, '_blank');
            return null;
        }
                <#assign dataview_de = dataview.getPSAppDataEntity().getPSDataEntity()/>
        const url: string = '/${app.getPKGCodeName()?lower_case}/${dataview_de.getPSSystemModule().codeName?lower_case}/${dataview_de.codeName?lower_case}/${dataview.getPSDEViewCodeName()?lower_case}/getmodel';
        actionContext.$http.get(url, data).then((response: any) => {
            if (!response || response.status !== 200) {
                actionContext.$Notice.error({ title: '错误', desc: '请求异常' });
            }
            if (response.status === 401) {
                return;
            }
            const { data: result } = response;
            if (!result) {
                return reject(response);
            }

            if (result.viewparams && Object.keys(result.viewparams)) {
                Object.assign(data, result.viewparams);
            }

            if (Object.is(result.openmode, 'POPUPAPP') && result.url && !Object.is(result.url, '')) {
                openPopupApp(result.url);
            } else if (Object.is(result.openmode, 'INDEXVIEWTAB') || Object.is(result.openmode, '')) {
                const viewpath = ${r'`${result.viewmodule}_${result.viewname}`.toLowerCase()'};
                return openIndexViewTab(viewpath, data);
            } else if (Object.is(result.openmode, 'POPUPMODAL')) {
                const viewname = actionContext.$util.srfFilePath2(result.viewname);
                const view: any = {
                    viewname: viewname,
                    title: result.title,
                    width: result.width,
                    height: result.height,
                }
                return openPopupModal(view,context,data);
            } else if (result.openmode.startsWith('DRAWER')) {
                const viewname = actionContext.$util.srfFilePath2(result.viewname);
                const view: any = {
                    viewname: viewname,
                    title: result.title,
                    width: result.width,
                    height: result.height,
                    placement: result.openmode,
                }
                return openDrawer(view,context,data);
            } else if (Object.is(result.openmode, 'POPOVER')) {
                const viewname = actionContext.$util.srfFilePath2(result.viewname);
                const view: any = {
                    viewname: viewname,
                    title: result.title,
                    width: result.width,
                    height: result.height,
                    placement: result.openmode,
                }
                return openPopOver(view,context,data);
            }  
        }).catch((response: any) => {
            if (!response || !response.status || !response.data) {
                actionContext.$Notice.error({ title: '错误', desc: '系统异常！' });
                return;
            }
            if (response.status === 401) {
                return;
            }
        })
        <#-- END: 打开独立程序弹出  -->
      <#--  END: 打开重定向视图  -->
      <#--  BEGIN: 打开顶级分页视图  -->
            <#elseif dataview.getOpenMode() =='INDEXVIEWTAB' || dataview.getOpenMode() == ''>
        const openIndexViewTab = (data: any) => {
            const routePath = actionContext.$viewTool.buildUpRoutePath(actionContext.$route, context, deResParameters, parameters, _args, data);
            actionContext.$router.push(routePath);
            //  后续界面行为
            <@nextUIActionLogic 'args' />
        }
        return openIndexViewTab(data);
      <#--  END: 打开顶级分页视图  -->
      <#-- BEGIN: 打开模态  -->
            <#elseif dataview.getOpenMode() = 'POPUPMODAL'>
        const openPopupModal = (view: any, data: any) => {
            let container: Subject<any> = actionContext.$appmodal.openModal(view, context, data);
            container.subscribe((result: any) => {
                if (!result || !Object.is(result.ret, 'OK')) {
                    return;
                }
                const _this: any = actionContext;
                //  后续界面行为
                <@nextUIActionLogic 'result.datas' />
            });
        }
        const view: any = {
            viewname: '${srffilepath2(dataview.getCodeName())}', 
            height: ${dataview.getHeight()?c}, 
            width: ${dataview.getWidth()?c},  
            title: actionContext.<@getViewLanguageTitle dataview />,
        };
        return openPopupModal(view, data);
      <#-- END: 打开模态  -->
      <#--  BEGIN: 打开抽屉  -->
            <#elseif dataview.getOpenMode()?index_of('DRAWER') == 0>
        const openDrawer = (view: any, data: any) => {
            let container: Subject<any> = actionContext.$appdrawer.openDrawer(view, context,data);
            container.subscribe((result: any) => {
                if (!result || !Object.is(result.ret, 'OK')) {
                    return;
                }
                //  后续界面行为
                <@nextUIActionLogic 'result.datas' />
            });
        }
        const view: any = {
            viewname: '${srffilepath2(dataview.getCodeName())}', 
            height: ${dataview.getHeight()?c}, 
            width: ${dataview.getWidth()?c},  
            title: actionContext.<@getViewLanguageTitle dataview />,
            placement: '${dataview.getOpenMode()}',
        };
        return openDrawer(view, data);
      <#--  END: 打开抽屉  -->
      <#--  BEGIN: 打开气泡卡片  -->
            <#elseif dataview.getOpenMode() == 'POPOVER'>
            const openPopOver = (view: any, data: any) => {
                let container: Subject<any> = actionContext.$apppopover.openPop($event, view, context,data);
                container.subscribe((result: any) => {
                    if (!result || !Object.is(result.ret, 'OK')) {
                        return;
                    }
                    const _this: any = actionContext;
                    //  后续界面行为
                    <@nextUIActionLogic 'result.datas' />
                });
            }
            const view: any = {
                viewname: '${srffilepath2(dataview.getCodeName())}', 
                height: ${dataview.getHeight()?c}, 
                width: ${dataview.getWidth()?c},  
                title: actionContext.<@getViewLanguageTitle dataview />,
                placement: '${dataview.getOpenMode()}',
            };
            return openPopOver(view, data);
      <#--  END: 打开气泡卡片  -->
      <#--  BEGIN: 其他打开模式  -->
                <#else>
        actionContext.$Notice.warning({ title: '错误', desc: actionContext.<@getViewLanguageTitle dataview />+'不支持该模式打开' });
                </#if>
      <#--  END: 其他打开模式  -->
    <#--  END: 前台处理模式：打开顶级视图，打开顶级视图或向导（模态）  -->
    <#--  BEGIN: 前台处理模式：用户自定义  -->
            <#elseif item.getFrontProcessType() == 'OTHER'>
                // 自定义实体界面行为
                actionContext.$Notice.warning({ title: '错误', desc: '${item.getCaption()} 未实现' });
                //  后续界面行为
                <@nextUIActionLogic 'null' />
            </#if>
        </#if>
    </#if>
    }
</#if>
    